| OpendTect 8.0

Loading...
Searching...
No Matches
Public Types | Public Member Functions | Static Public Member Functions | Public Attributes | Protected Member Functions | Static Protected Member Functions | Protected Attributes | Static Private Member Functions | Private Attributes | Friends | List of all members
SurveyInfo Class Reference
Basic

Holds survey general information. More...

`#include <survinfo.h>`

Inheritance diagram for SurveyInfo:
[legend]

## Public Types
using | Pol2D3D = OD::Pol2D3D
enum | Unit { Second , Meter , Feet }
Public Types inherited from ObjectWithName
typedef OD::String | name_type

## Public Member Functions
| SurveyInfo (const SurveyInfo &)
| ~SurveyInfo ()
float | angleXCrl () const
float | angleXInl () const
const Pos::IdxPair2Coord & | binID2Coord () const
void | checkCrlRange (Interval< int > &, bool work) const
| Makes sure range is inside.
void | checkInlRange (Interval< int > &, bool work) const
| Makes sure range is inside.
void | checkZRange (Interval< float > &, bool work) const
| Makes sure range is inside.
const char * | comment () const
float | crlDistance () const
StepInterval< int > | crlRange () const
StepInterval< int > | crlRange (bool work) const
int | crlStep () const
bool | depthsInFeet () const
ZDomain::DepthType | depthType () const
const SurveyDiskLocation & | diskLocation () const
void | gen3Pts ()
RefMan< Survey::Geometry3D > | get3DGeometry (bool work)
ConstRefMan< Survey::Geometry3D > | get3DGeometry (bool work) const
void | get3Pts (Coord c[3], BinID b[2], int &xline) const
float | getArea (bool work) const
| returns m2
float | getArea (const Interval< int > &inl, const Interval< int > &crl) const
| returns m2
Pos::IdxPair2Coord & | getBinID2Coord () const
RefMan< Coords::CoordSystem > | getCoordSystem ()
ConstRefMan< Coords::CoordSystem > | getCoordSystem () const
BufferString | getDataDirName () const
BufferString | getDirName () const
LatLong2Coord & | getLatlong2Coord () const
IOPar & | getLogPars () const
IOPar & | getPars () const
uiString | getUiXYUnitString (bool abbrviated=true, bool withparens=true) const
const uiString | getUiZUnitString (bool withparens=true) const
const char * | getXYUnitString (bool withparens=true) const
const char * | getZUnitString (bool withparens=true) const
bool | has2D () const
bool | has3D () const
bool | hasProjection () const
bool | includes (const BinID &, const float, bool work) const
| Returns true when pos is inside survey-range.
float | inlDistance () const
| distance for one increment
StepInterval< int > | inlRange () const
StepInterval< int > | inlRange (bool work) const
int | inlStep () const
bool | isClockWise () const
| Don't use. Will be removed.
bool | isInside (const BinID &, bool work) const
bool | isReasonable (const BinID &) const
| Checks if in or near survey.
bool | isReasonable (const Coord &) const
| Checks if in or near survey.
bool | isRightHandSystem () const
bool | isWorkRangeSet () const
const LatLong2Coord & | latlong2Coord () const
const IOPar & | logPars () const
| Return survey creation log.
Coord | maxCoord (bool work) const
int | maxNrTraces (bool work) const
Coord | minCoord (bool work) const
int | nrXYDecimals () const
int | nrZDecimals (bool usepref=true) const
Coord3 | oneStepTranslation (const Coord3 &planenormal) const
bool | operator!= (const SurveyInfo &) const
SurveyInfo & | operator= (const SurveyInfo &)
bool | operator== (const SurveyInfo &) const
const IOPar & | pars () const
| Returns contents of .defs file.
void | putZDomain (IOPar &) const
void | readSavedCoordSystem () const
| Useful after loading plugins.
Interval< int > | reasonableRange (bool inl) const
const TrcKeyZSampling & | sampling (bool work) const
void | saveLog (const char *basedir=nullptr) const
void | savePars (const char *basedir=nullptr, OD::JSON::Object *obj=nullptr) const
| Write to .defs file.
float | seismicReferenceDatum () const
const char * | set3Pts (const Coord c[3], const BinID b[2], int xline)
uiString | set3PtsWithMsg (const Coord c[3], const BinID b[2], int xline)
void | setComment (const char *s)
bool | setCoordSystem (const Coords::CoordSystem *)
void | setDepthInFeet (bool yn=true)
void | setRange (const TrcKeyZSampling &, bool)
void | setSeismicReferenceDatum (float d)
void | setSipName (const uiString &sipnm)
void | setSurvDataType (OD::Pol2D3D typ)
void | setTr (double, double, double, bool isx)
void | setWorkRange (const TrcKeyZSampling &)
void | setXYInFeet (bool yn=true)
void | setZUnit (bool istime, bool infeet=false)
float | showZ2UserFactor () const
uiString | sipName () const
void | snap (BinID &, const BinID &dir=BinID(0, 0)) const
| dir = 0 : auto; -1 round downward, 1 round upward
void | snapStep (BinID &, const BinID &dir=BinID(0, 0)) const
| see snap() for direction
void | snapZ (float &, int direction=0) const
| see snap() for direction
OD::Pol2D3D | survDataType () const
Coord | transform (const BinID &b) const
BinID | transform (const Coord &) const
void | update3DGeometry ()
void | updateDirName ()
| May be used after setName()
bool | write (const char *basedir=nullptr, bool isjson=false) const
| Write to .survey file.
bool | xyInFeet () const
OD::XYType | xyUnit () const
const ZDomain::Def & | zDomain () const
const ZDomain::Info & | zDomainInfo () const
bool | zInFeet () const
bool | zInMeter () const
bool | zIsTime () const
const StepInterval< float > & | zRange () const
const StepInterval< float > & | zRange (bool work) const
float | zScale (bool display=true) const
float | zStep () const
Unit | zUnit () const
Unit | zUnit (bool display) const
Public Member Functions inherited from NamedCallBacker
| NamedCallBacker (const char *nm=nullptr)
| NamedCallBacker (const NamedCallBacker &)=delete
| ~NamedCallBacker ()
virtual Notifier< NamedCallBacker > & | objectToBeDeleted () const
NamedCallBacker & | operator= (const NamedCallBacker &)=delete
bool | operator== (const NamedCallBacker &oth) const
bool | operator== (const NamedObject &oth) const
Public Member Functions inherited from CallBacker
| CallBacker ()
| CallBacker (const CallBacker &)
virtual | ~CallBacker ()
bool | attachCB (const NotifierAccess &, const CallBack &, bool onlyifnew=false) const
bool | attachCB (const NotifierAccess *notif, const CallBack &cb, bool onlyifnew=false) const
void | detachAllNotifiers () const
| Call from the destructor of your inherited object.
void | detachCB (const NotifierAccess &, const CallBack &) const
void | detachCB (const NotifierAccess *notif, const CallBack &cb) const
virtual bool | isCapsule () const
bool | isNotifierAttached (const NotifierAccess *) const
| Only for debugging purposes, don't use.
CallBacker & | operator= (const CallBacker &)=delete
void | stopReceivingNotifications () const
virtual CallBacker * | trueCaller ()
Public Member Functions inherited from NamedObject
| NamedObject (const char *nm=nullptr)
| NamedObject (const NamedObject &oth)
virtual | ~NamedObject ()
virtual BufferString | getName () const
bool | getNameFromPar (const IOPar &)
const name_type & | name () const override
NamedObject & | operator= (const NamedObject &)
bool | operator== (const NamedObject &oth) const
virtual void | setName (const char *nm)
Public Member Functions inherited from ObjectWithName
virtual | ~ObjectWithName ()
bool | hasName (const char *nm) const
bool | hasName (const name_type &nm) const
void | putNameInPar (IOPar &) const

## Static Public Member Functions
static const char * | curSurveyName ()
| Survey directory name (not a full path)
static float | defaultXYtoZScale (Unit, OD::XYType)
static void | deleteInstance ()
static SurveyInfo & | empty ()
static Notifier< SurveyInfo > & | instanceCreated ()
static uiRetVal | isValidDataRoot (const char *)
static uiRetVal | isValidSurveyDir (const char *)
static SurveyInfo * | popSI ()
static void | pushSI (SurveyInfo *)
static SurveyInfo * | readDirectory (const char *loc)
static SurveyInfo * | readFile (const char *loc)
static Notifier< SurveyInfo > & | rootDirChanged ()
static const char * | sKeyBasicSurveyName ()
static const char * | sKeyComments ()
static const char * | sKeyCrlRange ()
static const char * | sKeyCRS ()
static const char * | sKeyDef ()
static const char * | sKeyDomain ()
static const char * | sKeyDpthInFt ()
| Not used by SI, just a UI default.
static const char * | sKeyIC ()
static const char * | sKeyInlRange ()
static const char * | sKeyProjVersion ()
static const char * | sKeySeismicRefDatum ()
static const char * | sKeySetPt ()
static const char * | sKeySetupFileName ()
static const char * | sKeySurvDataType ()
static const char * | sKeySurvDiskLoc ()
static const char * | sKeyTransformation ()
static const char * | sKeyXRange ()
static const char * | sKeyXY ()
static const char * | sKeyXYInFt ()
static const char * | sKeyYRange ()
static const char * | sKeyZAxis ()
static const char * | sKeyZRange ()
Static Public Member Functions inherited from CallBacker
static void | createReceiverForCurrentThread ()
static void | removeReceiverForCurrentThread ()

## Public Attributes
Notifier< SurveyInfo > | workRangeChg

## Protected Member Functions
| SurveyInfo ()
void | handleTransformData (const BufferString &, const char *)
void | putTr (const Pos::IdxPair2Coord::DirTransform &, ascostream &, const char *) const
void | setTr (Pos::IdxPair2Coord::DirTransform &, const char *)
bool | wrapUpRead ()
void | writeSpecLines (ascostream *, OD::JSON::Object *obj=nullptr) const
Protected Member Functions inherited from NamedCallBacker
void | sendDelNotif () const

## Static Protected Member Functions
static SurveyInfo * | readJSON (const OD::JSON::Object &, uiRetVal &)
static SurveyInfo * | readStrm (od_istream &, uiRetVal &)

## Protected Attributes
Pos::IdxPair2Coord | b2c_
BufferString | comment_
ConstRefMan< Coords::CoordSystem > | coordsystem_
ZDomain::DepthType | depthtype_ = ZDomain::DepthType::Meter
SurveyDiskLocation | disklocation_
LatLong2Coord & | ll2c_
IOPar | logpars_
IOPar & | pars_
float | seisrefdatum_ = 0.f
BinID | set3binids_ [3]
Coord | set3coords_ [3]
uiString | sipnm_
OD::Pol2D3D | survdatatype_
bool | survdatatypeknown_ = false
TrcKeyZSampling & | tkzs_
TrcKeyZSampling & | wcs_
RefMan< Survey::Geometry3D > | work_s3dgeom_
OD::XYType | xytype_ = OD::XYType::Meter
const ZDomain::Info * | zdomain_ = &ZDomain::TWT()
Protected Attributes inherited from NamedCallBacker
Threads::Atomic< bool > | delalreadytriggered_
Notifier< NamedCallBacker > | delnotif_
Protected Attributes inherited from NamedObject
BufferString | name_

## Static Private Member Functions
static void | setSurveyName (const char *surveydirnm)
static const char * | surveyFileName ()

## Private Attributes
Pos::IdxPair2Coord::DirTransform | rdxtr_
Pos::IdxPair2Coord::DirTransform | rdytr_

## Friends
class | EmptyTempSurvey
class | IOMan
const SurveyInfo & | SI ()
class | uiSurvey
class | uiSurveyInfoEditor
class | uiSurveyMap

## Detailed Description

Holds survey general information.

The surveyinfo is the primary source for ranges and steps.It also provides the transformation between inline/xline <-> coordinates and lat/long estimates

Note: the Z range step is only a default. It should not be used further because different cubes/lines have different sample rates.

The ranges are defined for two cubes: the entire survey, and a 'working area'. Normally, you'll want to have the working area.

If you are an expert, and you feel you need more 'power', you may want to look at the bottom part of the class too for some more public functions.

<>

## Member Typedef Documentation

## ◆ Pol2D3D

using SurveyInfo::Pol2D3D = OD::Pol2D3D

## Member Enumeration Documentation

## ◆ Unit

enum SurveyInfo::Unit

Enumerator
Second |
Meter |
Feet |

## Constructor & Destructor Documentation

## ◆ ~SurveyInfo()

SurveyInfo::~SurveyInfo | ( |  | ) |

## ◆ SurveyInfo() [1/2]

SurveyInfo::SurveyInfo | ( |  | ) |
| protected

## ◆ SurveyInfo() [2/2]

SurveyInfo::SurveyInfo | ( | const SurveyInfo & |  | ) |

## Member Function Documentation

## ◆ angleXCrl()

float SurveyInfo::angleXCrl | ( |  | ) | const

It's the angle between the X-axis (East) and a Crossline

## ◆ angleXInl()

float SurveyInfo::angleXInl | ( |  | ) | const

It's the angle between the X-axis (East) and an Inline

## ◆ binID2Coord()

const Pos::IdxPair2Coord & SurveyInfo::binID2Coord | ( |  | ) | const
| inline

## ◆ checkCrlRange()

void SurveyInfo::checkCrlRange | ( | Interval< int > & | ,
|  | bool | work ) const

Makes sure range is inside.

## ◆ checkInlRange()

void SurveyInfo::checkInlRange | ( | Interval< int > & | ,
|  | bool | work ) const

Makes sure range is inside.

## ◆ checkZRange()

void SurveyInfo::checkZRange | ( | Interval< float > & | ,
|  | bool | work ) const

Makes sure range is inside.

## ◆ comment()

const char * SurveyInfo::comment | ( |  | ) | const
| inline

## ◆ crlDistance()

float SurveyInfo::crlDistance | ( |  | ) | const

## ◆ crlRange() [1/2]

StepInterval< int > SurveyInfo::crlRange | ( |  | ) | const
| inline

## ◆ crlRange() [2/2]

StepInterval< int > SurveyInfo::crlRange | ( | bool | work | ) | const

## ◆ crlStep()

int SurveyInfo::crlStep | ( |  | ) | const

## ◆ curSurveyName()

static const char * SurveyInfo::curSurveyName | ( |  | ) |
| static

Survey directory name (not a full path)

## ◆ defaultXYtoZScale()

static float SurveyInfo::defaultXYtoZScale | ( | Unit | ,
|  | OD::XYType | )
| static

Gives a ballpark figure of how to scale XY to make it comparable to Z.

## ◆ deleteInstance()

static void SurveyInfo::deleteInstance | ( |  | ) |
| inline static

## ◆ depthsInFeet()

bool SurveyInfo::depthsInFeet | ( |  | ) | const

## ◆ depthType()

ZDomain::DepthType SurveyInfo::depthType | ( |  | ) | const

## ◆ diskLocation()

const SurveyDiskLocation & SurveyInfo::diskLocation | ( |  | ) | const

## ◆ empty()

static SurveyInfo & SurveyInfo::empty | ( |  | ) |
| static

## ◆ gen3Pts()

void SurveyInfo::gen3Pts | ( |  | ) |

## ◆ get3DGeometry() [1/2]

RefMan< Survey::Geometry3D > SurveyInfo::get3DGeometry | ( | bool | work | ) |

## ◆ get3DGeometry() [2/2]

ConstRefMan< Survey::Geometry3D > SurveyInfo::get3DGeometry | ( | bool | work | ) | const

## ◆ get3Pts()

void SurveyInfo::get3Pts | ( | Coord | c[3],
|  | BinID | b[2],
|  | int & | xline ) const

## ◆ getArea() [1/2]

float SurveyInfo::getArea | ( | bool | work | ) | const

returns m2

## ◆ getArea() [2/2]

float SurveyInfo::getArea | ( | const Interval< int > & | inl,
|  | const Interval< int > & | crl ) const

returns m2

## ◆ getBinID2Coord()

Pos::IdxPair2Coord & SurveyInfo::getBinID2Coord | ( |  | ) | const
| inline

## ◆ getCoordSystem() [1/2]

RefMan< Coords::CoordSystem > SurveyInfo::getCoordSystem | ( |  | ) |

## ◆ getCoordSystem() [2/2]

ConstRefMan< Coords::CoordSystem > SurveyInfo::getCoordSystem | ( |  | ) | const

## ◆ getDataDirName()

BufferString SurveyInfo::getDataDirName | ( |  | ) | const

## ◆ getDirName()

BufferString SurveyInfo::getDirName | ( |  | ) | const

## ◆ getLatlong2Coord()

LatLong2Coord & SurveyInfo::getLatlong2Coord | ( |  | ) | const
| inline

## ◆ getLogPars()

IOPar & SurveyInfo::getLogPars | ( |  | ) | const
| inline

## ◆ getPars()

IOPar & SurveyInfo::getPars | ( |  | ) | const
| inline

## ◆ getUiXYUnitString()

uiString SurveyInfo::getUiXYUnitString | ( | bool | abbrviated = true,
|  | bool | withparens = true ) const

## ◆ getUiZUnitString()

const uiString SurveyInfo::getUiZUnitString | ( | bool | withparens = true | ) | const
| inline

## ◆ getXYUnitString()

const char * SurveyInfo::getXYUnitString | ( | bool | withparens = true | ) | const

## ◆ getZUnitString()

const char * SurveyInfo::getZUnitString | ( | bool | withparens = true | ) | const
| inline

## ◆ handleTransformData()

void SurveyInfo::handleTransformData | ( | const BufferString & | ,
|  | const char * | )
| protected

## ◆ has2D()

bool SurveyInfo::has2D | ( |  | ) | const

## ◆ has3D()

bool SurveyInfo::has3D | ( |  | ) | const

## ◆ hasProjection()

bool SurveyInfo::hasProjection | ( |  | ) | const

## ◆ includes()

bool SurveyInfo::includes | ( | const BinID & | ,
|  | const float | ,
|  | bool | work ) const

Returns true when pos is inside survey-range.

## ◆ inlDistance()

float SurveyInfo::inlDistance | ( |  | ) | const

distance for one increment

## ◆ inlRange() [1/2]

StepInterval< int > SurveyInfo::inlRange | ( |  | ) | const
| inline

## ◆ inlRange() [2/2]

StepInterval< int > SurveyInfo::inlRange | ( | bool | work | ) | const

## ◆ inlStep()

int SurveyInfo::inlStep | ( |  | ) | const

## ◆ instanceCreated()

static Notifier< SurveyInfo > & SurveyInfo::instanceCreated | ( |  | ) |
| static

## ◆ isClockWise()

bool SurveyInfo::isClockWise | ( |  | ) | const
| inline

Don't use. Will be removed.

## ◆ isInside()

bool SurveyInfo::isInside | ( | const BinID & | ,
|  | bool | work ) const

## ◆ isReasonable() [1/2]

bool SurveyInfo::isReasonable | ( | const BinID & |  | ) | const

Checks if in or near survey.

## ◆ isReasonable() [2/2]

bool SurveyInfo::isReasonable | ( | const Coord & |  | ) | const

Checks if in or near survey.

## ◆ isRightHandSystem()

bool SurveyInfo::isRightHandSystem | ( |  | ) | const

Orientation is determined by rotating the inline axis to the crossline axis.

## ◆ isValidDataRoot()

static uiRetVal SurveyInfo::isValidDataRoot | ( | const char * |  | ) |
| static

Full path to a writable directory Exclusively for usage in modules below General

## ◆ isValidSurveyDir()

static uiRetVal SurveyInfo::isValidSurveyDir | ( | const char * |  | ) |
| static

Full path to an OpendTect project directory Exclusively for usage in modules below General

## ◆ isWorkRangeSet()

bool SurveyInfo::isWorkRangeSet | ( |  | ) | const

## ◆ latlong2Coord()

const LatLong2Coord & SurveyInfo::latlong2Coord | ( |  | ) | const
| inline

## ◆ logPars()

const IOPar & SurveyInfo::logPars | ( |  | ) | const
| inline

Return survey creation log.

## ◆ maxCoord()

Coord SurveyInfo::maxCoord | ( | bool | work | ) | const

## ◆ maxNrTraces()

int SurveyInfo::maxNrTraces | ( | bool | work | ) | const

## ◆ minCoord()

Coord SurveyInfo::minCoord | ( | bool | work | ) | const

## ◆ nrXYDecimals()

int SurveyInfo::nrXYDecimals | ( |  | ) | const

## ◆ nrZDecimals()

int SurveyInfo::nrZDecimals | ( | bool | usepref = true | ) | const

## ◆ oneStepTranslation()

Coord3 SurveyInfo::oneStepTranslation | ( | const Coord3 & | planenormal | ) | const

## ◆ operator!=()

bool SurveyInfo::operator!= | ( | const SurveyInfo & |  | ) | const

## ◆ operator=()

SurveyInfo & SurveyInfo::operator= | ( | const SurveyInfo & |  | ) |

## ◆ operator==()

bool SurveyInfo::operator== | ( | const SurveyInfo & |  | ) | const

## ◆ pars()

const IOPar & SurveyInfo::pars | ( |  | ) | const
| inline

Returns contents of .defs file.

## ◆ popSI()

static SurveyInfo * SurveyInfo::popSI | ( |  | ) |
| static

## ◆ pushSI()

static void SurveyInfo::pushSI | ( | SurveyInfo * |  | ) |
| static

## ◆ putTr()

void SurveyInfo::putTr | ( | const Pos::IdxPair2Coord::DirTransform & | ,
|  | ascostream & | ,
|  | const char * | ) const
| protected

## ◆ putZDomain()

void SurveyInfo::putZDomain | ( | IOPar & |  | ) | const

## ◆ readDirectory()

static SurveyInfo * SurveyInfo::readDirectory | ( | const char * | loc | ) |
| static

## ◆ readFile()

static SurveyInfo * SurveyInfo::readFile | ( | const char * | loc | ) |
| static

## ◆ readJSON()

static SurveyInfo * SurveyInfo::readJSON | ( | const OD::JSON::Object & | ,
|  | uiRetVal & | )
| static protected

## ◆ readSavedCoordSystem()

void SurveyInfo::readSavedCoordSystem | ( |  | ) | const

Useful after loading plugins.

## ◆ readStrm()

static SurveyInfo * SurveyInfo::readStrm | ( | od_istream & | ,
|  | uiRetVal & | )
| static protected

## ◆ reasonableRange()

Interval< int > SurveyInfo::reasonableRange | ( | bool | inl | ) | const

## ◆ rootDirChanged()

static Notifier< SurveyInfo > & SurveyInfo::rootDirChanged | ( |  | ) |
| static

## ◆ sampling()

const TrcKeyZSampling & SurveyInfo::sampling | ( | bool | work | ) | const
| inline

## ◆ saveLog()

void SurveyInfo::saveLog | ( | const char * | basedir = nullptr | ) | const

## ◆ savePars()

void SurveyInfo::savePars | ( | const char * | basedir = nullptr,
|  | OD::JSON::Object * | obj = nullptr ) const

Write to .defs file.

## ◆ seismicReferenceDatum()

float SurveyInfo::seismicReferenceDatum | ( |  | ) | const
| inline

In depth units (m or ft), positive upward from sea level. Always in meters for time surveys

## ◆ set3Pts()

const char * SurveyInfo::set3Pts | ( | const Coord | c[3],
|  | const BinID | b[2],
|  | int | xline )

## ◆ set3PtsWithMsg()

uiString SurveyInfo::set3PtsWithMsg | ( | const Coord | c[3],
|  | const BinID | b[2],
|  | int | xline )

## ◆ setComment()

void SurveyInfo::setComment | ( | const char * | s | ) |
| inline

## ◆ setCoordSystem()

bool SurveyInfo::setCoordSystem | ( | const Coords::CoordSystem * |  | ) |

## ◆ setDepthInFeet()

void SurveyInfo::setDepthInFeet | ( | bool | yn = true | ) |

## ◆ setRange()

void SurveyInfo::setRange | ( | const TrcKeyZSampling & | ,
|  | bool | )

## ◆ setSeismicReferenceDatum()

void SurveyInfo::setSeismicReferenceDatum | ( | float | d | ) |
| inline

## ◆ setSipName()

void SurveyInfo::setSipName | ( | const uiString & | sipnm | ) |
| inline

## ◆ setSurvDataType()

void SurveyInfo::setSurvDataType | ( | OD::Pol2D3D | typ | ) |
| inline

## ◆ setSurveyName()

static void SurveyInfo::setSurveyName | ( | const char * | surveydirnm | ) |
| static private

## ◆ setTr() [1/2]

void SurveyInfo::setTr | ( | double | ,
|  | double | ,
|  | double | ,
|  | bool | isx )

## ◆ setTr() [2/2]

void SurveyInfo::setTr | ( | Pos::IdxPair2Coord::DirTransform & | ,
|  | const char * | )
| protected

## ◆ setWorkRange()

void SurveyInfo::setWorkRange | ( | const TrcKeyZSampling & |  | ) |

## ◆ setXYInFeet()

void SurveyInfo::setXYInFeet | ( | bool | yn = true | ) |

## ◆ setZUnit()

void SurveyInfo::setZUnit | ( | bool | istime,
|  | bool | infeet = false )

## ◆ showZ2UserFactor()

float SurveyInfo::showZ2UserFactor | ( |  | ) | const
| inline

## ◆ sipName()

uiString SurveyInfo::sipName | ( |  | ) | const
| inline

## ◆ sKeyBasicSurveyName()

static const char * SurveyInfo::sKeyBasicSurveyName | ( |  | ) |
| inline static

## ◆ sKeyComments()

static const char * SurveyInfo::sKeyComments | ( |  | ) |
| inline static

## ◆ sKeyCrlRange()

static const char * SurveyInfo::sKeyCrlRange | ( |  | ) |
| static

## ◆ sKeyCRS()

static const char * SurveyInfo::sKeyCRS | ( |  | ) |
| inline static

## ◆ sKeyDef()

static const char * SurveyInfo::sKeyDef | ( |  | ) |
| inline static

## ◆ sKeyDomain()

static const char * SurveyInfo::sKeyDomain | ( |  | ) |
| inline static

## ◆ sKeyDpthInFt()

static const char * SurveyInfo::sKeyDpthInFt | ( |  | ) |
| static

Not used by SI, just a UI default.

## ◆ sKeyIC()

static const char * SurveyInfo::sKeyIC | ( |  | ) |
| inline static

## ◆ sKeyInlRange()

static const char * SurveyInfo::sKeyInlRange | ( |  | ) |
| static

## ◆ sKeyProjVersion()

static const char * SurveyInfo::sKeyProjVersion | ( |  | ) |
| inline static

## ◆ sKeySeismicRefDatum()

static const char * SurveyInfo::sKeySeismicRefDatum | ( |  | ) |
| static

## ◆ sKeySetPt()

static const char * SurveyInfo::sKeySetPt | ( |  | ) |
| inline static

## ◆ sKeySetupFileName()

static const char * SurveyInfo::sKeySetupFileName | ( |  | ) |
| inline static

## ◆ sKeySurvDataType()

static const char * SurveyInfo::sKeySurvDataType | ( |  | ) |
| static

## ◆ sKeySurvDiskLoc()

static const char * SurveyInfo::sKeySurvDiskLoc | ( |  | ) |
| inline static

## ◆ sKeyTransformation()

static const char * SurveyInfo::sKeyTransformation | ( |  | ) |
| inline static

## ◆ sKeyXRange()

static const char * SurveyInfo::sKeyXRange | ( |  | ) |
| static

## ◆ sKeyXY()

static const char * SurveyInfo::sKeyXY | ( |  | ) |
| inline static

## ◆ sKeyXYInFt()

static const char * SurveyInfo::sKeyXYInFt | ( |  | ) |
| static

## ◆ sKeyYRange()

static const char * SurveyInfo::sKeyYRange | ( |  | ) |
| static

## ◆ sKeyZAxis()

static const char * SurveyInfo::sKeyZAxis | ( |  | ) |
| inline static

## ◆ sKeyZRange()

static const char * SurveyInfo::sKeyZRange | ( |  | ) |
| static

## ◆ snap()

void SurveyInfo::snap | ( | BinID & | ,
|  | const BinID & | dir = BinID(0, 0) ) const

dir = 0 : auto; -1 round downward, 1 round upward

## ◆ snapStep()

void SurveyInfo::snapStep | ( | BinID & | ,
|  | const BinID & | dir = BinID(0, 0) ) const

see snap() for direction

## ◆ snapZ()

void SurveyInfo::snapZ | ( | float & | ,
|  | int | direction = 0 ) const

see snap() for direction

## ◆ survDataType()

OD::Pol2D3D SurveyInfo::survDataType | ( |  | ) | const
| inline

## ◆ surveyFileName()

static const char * SurveyInfo::surveyFileName | ( |  | ) |
| static private

## ◆ transform() [1/2]

Coord SurveyInfo::transform | ( | const BinID & | b | ) | const

## ◆ transform() [2/2]

BinID SurveyInfo::transform | ( | const Coord & |  | ) | const

Note
  BinID will be snapped using work step.

## ◆ update3DGeometry()

void SurveyInfo::update3DGeometry | ( |  | ) |

## ◆ updateDirName()

void SurveyInfo::updateDirName | ( |  | ) |

May be used after setName()

## ◆ wrapUpRead()

bool SurveyInfo::wrapUpRead | ( |  | ) |
| protected

## ◆ write()

bool SurveyInfo::write | ( | const char * | basedir = nullptr,
|  | bool | isjson = false ) const

Write to .survey file.

## ◆ writeSpecLines()

void SurveyInfo::writeSpecLines | ( | ascostream * | ,
|  | OD::JSON::Object * | obj = nullptr ) const
| protected

## ◆ xyInFeet()

bool SurveyInfo::xyInFeet | ( |  | ) | const

## ◆ xyUnit()

OD::XYType SurveyInfo::xyUnit | ( |  | ) | const

## ◆ zDomain()

const ZDomain::Def & SurveyInfo::zDomain | ( |  | ) | const

## ◆ zDomainInfo()

const ZDomain::Info & SurveyInfo::zDomainInfo | ( |  | ) | const

## ◆ zInFeet()

bool SurveyInfo::zInFeet | ( |  | ) | const

## ◆ zInMeter()

bool SurveyInfo::zInMeter | ( |  | ) | const

## ◆ zIsTime()

bool SurveyInfo::zIsTime | ( |  | ) | const

## ◆ zRange() [1/2]

const StepInterval< float > & SurveyInfo::zRange | ( |  | ) | const
| inline

## ◆ zRange() [2/2]

const StepInterval< float > & SurveyInfo::zRange | ( | bool | work | ) | const

## ◆ zScale()

float SurveyInfo::zScale | ( | bool | display = true | ) | const

Gives a ballpark figure of how to scale Z to make it comparable to XY.

## ◆ zStep()

float SurveyInfo::zStep | ( |  | ) | const

## ◆ zUnit() [1/2]

Unit SurveyInfo::zUnit | ( |  | ) | const
| inline

## ◆ zUnit() [2/2]

Unit SurveyInfo::zUnit | ( | bool | display | ) | const

## Friends And Related Symbol Documentation

## ◆ EmptyTempSurvey

friend class EmptyTempSurvey
| friend

## ◆ IOMan

friend class IOMan
| friend

## ◆ SI

const SurveyInfo & SI | ( |  | ) |
| friend

## ◆ uiSurvey

friend class uiSurvey
| friend

## ◆ uiSurveyInfoEditor

friend class uiSurveyInfoEditor
| friend

## ◆ uiSurveyMap

friend class uiSurveyMap
| friend

## Member Data Documentation

## ◆ b2c_

Pos::IdxPair2Coord SurveyInfo::b2c_
| protected

## ◆ comment_

BufferString SurveyInfo::comment_
| protected

## ◆ coordsystem_

ConstRefMan<Coords::CoordSystem> SurveyInfo::coordsystem_
| protected

## ◆ depthtype_

ZDomain::DepthType SurveyInfo::depthtype_ = ZDomain::DepthType::Meter
| protected

## ◆ disklocation_

SurveyDiskLocation SurveyInfo::disklocation_
| protected

## ◆ ll2c_

LatLong2Coord& SurveyInfo::ll2c_
| protected

## ◆ logpars_

IOPar SurveyInfo::logpars_
| protected

## ◆ pars_

IOPar& SurveyInfo::pars_
| protected

## ◆ rdxtr_

Pos::IdxPair2Coord::DirTransform SurveyInfo::rdxtr_
| private

## ◆ rdytr_

Pos::IdxPair2Coord::DirTransform SurveyInfo::rdytr_
| private

## ◆ seisrefdatum_

float SurveyInfo::seisrefdatum_ = 0.f
| protected

## ◆ set3binids_

BinID SurveyInfo::set3binids_[3]
| protected

## ◆ set3coords_

Coord SurveyInfo::set3coords_[3]
| protected

## ◆ sipnm_

uiString SurveyInfo::sipnm_
| protected

## ◆ survdatatype_

OD::Pol2D3D SurveyInfo::survdatatype_
| protected

## ◆ survdatatypeknown_

bool SurveyInfo::survdatatypeknown_ = false
| protected

## ◆ tkzs_

TrcKeyZSampling& SurveyInfo::tkzs_
| protected

## ◆ wcs_

TrcKeyZSampling& SurveyInfo::wcs_
| protected

## ◆ work_s3dgeom_

RefMan<Survey::Geometry3D> SurveyInfo::work_s3dgeom_
| protected

## ◆ workRangeChg

Notifier<SurveyInfo> SurveyInfo::workRangeChg

## ◆ xytype_

OD::XYType SurveyInfo::xytype_ = OD::XYType::Meter
| protected

## ◆ zdomain_

const ZDomain::Info* SurveyInfo::zdomain_ = &ZDomain::TWT()
| protected

Generated at
for the OpendTect seismic interpretation project. Copyright (C): dGB Beheer B.V. 1995-2025